/**
* BUILDING FUNCTIONS - REMOVED
**/
//funciton creates an ordered array of objects (with class name key and list of element ID's)
function addDictionaryEntry(elemetntID,className){
  var classKey=className.indexOf("-")<0?className:className.toLowerCase().substring(0,className.indexOf("-"));//parse out the classKey
  var triggerEffect=className.indexOf("-")<0?"option":className.toLowerCase().substring(className.indexOf("-")+1);//trigger effect is the parsed out portion of the string
  //search through dataDictionary for a classKey that is the same or larger
  var dd = dataDictionary.length;
  for( var ii = 0;ii<dd;ii++){
    var compare = classKey.toLowerCase().localeCompare(dataDictionary[ii]['key'].toLowerCase()); 
    //if there is already a classkey
    if(compare==0){
       var jj =  dataDictionary[ii][triggerEffect].length;
       dataDictionary[ii][triggerEffect][jj] = elemetntID;
       return true;
    }
    //if the insert key is greater than the current key
    else if(compare<0){
       dataDictionary.splice(ii,0,createClassLookupObject(elemetntID,classKey,triggerEffect));
       return true;
    }
  } 
  //if no entries or largest comparotor - add at end.
  dataDictionary[dataDictionary.length]=createClassLookupObject(elemetntID,classKey,triggerEffect);
  return true;
}
function createClassLookupObject(elemetntID,classKey,triggerEffect){
  var lookupObject = {"option":[],"selected":[],"silent":[],"hidden":[]};
  lookupObject.key = classKey.toLowerCase();//index by lowercase lookup by lowercase
  lookupObject[triggerEffect] = [elemetntID];
  return lookupObject;
}

//Build the page on the fly
function loadPageFromXML(repr,loc){
  var now = new Date();
  loc.loadXML(window.CAREA_DEBUG?"http://localhost:8003/data/hwi_xmlSource.xml":Config.InterventionServer+"interventions/hwi-assistant/data/hwi_xmlSource.xml", function(xmldata) {
      var html=templateBuild({constants : loc.patient_data.constants, patient : loc.patient_data });
      repr.append(html);
      //Enable the save_button
      jQuery(repr).find("#carea_hwi_save_button").click(function(){
        repr.trigger("carea_ehrnotify", ["ehrnotify:ss?arg=108"]);
        alert(generateInterventionString(containerID));
      });
      /**
      * Enable the page
      **/
      jQuery(document).ready(function(){
        //buildPage(repr,html,loc.xmldata,loc.patient_data);
        var pre_template = html;
        jQuery("div.section_div",repr).each(function(){
            var elem = jQuery(this);
            var sect = jQuery(xmldata).find("section > name[text="+elem.attr('data-section')+"]").parent();//convert to html-string
            //find the area of the HTML and modify it with the appropriate load section
            var first = '" data-section ="'+elem.attr('data-section')+'">';
            var new_first = " "+elem.attr('data-section')+'" data-section ="'+elem.attr('data-section')+'">';
            var second = '</div>';
            var snake = loadSection(sect,loc.patient_data,xmldata);//convert to accept return string
            pre_template = pre_template.replace(first+second,new_first+snake+second);
        });
        //Part 2: build other sections (inside internal hidden container)
        var sects = jQuery(xmldata).find("section");
        var internal_snake="";var first = '<div id="carea_hwi_popup" class="silent">';//insertion tag...
        for(var ii=0;ii<sects.length;ii++){
          var name = jQuery(sects[ii]).find(">name").text();
          //if there is not a div with this section-name - build the HTML for this DIV as a hidden div
          if(!jQuery(repr).find("div[data-section="+name+"]").length){
            var div_attr={};
            div_attr['class'] = name + " silent";
            div_attr['data-section'] = name;
            var internal_snake=htmlDOMelement("div",div_attr,loadSection(sects[ii],loc.patient_data,xmldata));//convert to accept return string
            pre_template = pre_template.replace(first,first+internal_snake);
          }
          
        }
      //output to file, for templating
      console.log(pre_template);
      console.log(JSON.stringify(dataDictionary));
      //replace/testing mode
      jQuery(repr).html(pre_template);
        allowPlaceholder(repr);//fix quirks mode
        evaluateActions(repr);
        enableConditionalVisibility(repr);
        // initializeVisibility(loc.patient_data,loc.json_data,repr,loc.xmldata);
        // enableReciprocity(repr);
        // prepareTimestamps(repr);
        // enableHovering(repr);//fix quirks mode
        // jQuery(repr).find("input").click(function(){balanceColumns("#carea_hwi_right_side","#carea_hwi_left_side",repr);});
        // //reload previous fields
        // reloadData(loc.saved_data,repr);
        // //modifiers
        // jQuery("tr[class*=matrix]>td:first-child",repr).addClass("first_column");
        // //functions
        // jQuery("a.Resource_reference",repr).click(function(){
        //   //roll up selected resources
        //   var div = jQuery(this).parents("div.section_div");
        //   var local = (window.CAREA_DEBUG?"http://localhost:8003/":Config.InterventionServer+"interventions/hwi-assistant/");
        //   var pdf_append_url = Config.PDFServer + "/rules/pdf/api?";
        //   var pdfs_to_print = [];
        //   jQuery(":checked", div).each(function() {
        //     pdfs_to_print[pdfs_to_print.length]=local+jQuery(this).parents("div.div_row").find("a.reference,span.reference").attr("url");
        //   });
        //   if(pdfs_to_print.length==0){return false;}
        //   // construct query string
        //   var url = "pdfs="+pdfs_to_print.join("&pdfs=");
        //   repr.trigger("carea_ehrnotify", ["ehrnotify:CHOP_CARE_BROWSER^"+pdf_append_url+encodeURIComponent(url)]);
        //   div = local= pdf_append_url = pdfs_to_print = url = null;
        //   return false;
        // });
        
        jQuery('#carea_hwi_internal', repr).show();//show the main page.
        console.log(new Date().getTime()*1-now.getTime()*1);//time check for load)
    });
  });
  
}
//testing function for creating a value-low-high lab result
function obsValue(value,low,high){
  return {"value":value,"low":low,"high":high,"instant":"2014-10-17"};
}
//initialize visibility
function initializeVisibility(patient,json,repr,xml){
   jQuery(repr).find("div.div_row:not(.keeper),tr.div_row:not(.keeper)").addClass("hidden");//hide all rows without the keeper flag
   resolveAssertionIndexed("chop",patient,xml,repr);
   resolveAssertionIndexed("quest",patient,xml,repr);
   resolveAssertionIndexed("labcorp",patient,xml,repr);
   resolveAssertionIndexed("female",patient,xml,repr);
   resolveAssertionIndexed("male",patient,xml,repr);
   if(patient.constants.age_years>=10){createAssertion("over10")}
   complexCondition("overwten",["weightstatus_over","over10"],assertions);
   complexCondition("obeseten",["weightstatus_obese","over10"],assertions);
   //assertions
   for(assert in assertions){
      //console.log(assertions[assert]);
      triggerCascade(assertions[assert],1,repr);
   }
}
//For assertions with true fact in pateint object (no looping through patient.data)
function resolveAssertionIndexed(assertID,patient_data,intervention_data,repr){
    //data_dictionary concept entry
    var concept = jQuery(intervention_data).find("conceptId[text="+assertID+"]").parent();
    //patient lookup index
    var vID = jQuery(concept).find(">valueId").text();//from DD
    var cType=jQuery(concept).find(">conceptType").text();//from DD
    //for values with indexed section
    var pData = patient_data[cType][vID];
    if(pData!=null){
      jQuery(concept).find(">value").each(function(){
        if(equalsIgnoreCase(pData,jQuery(this).text())){
            triggerCascade(assertID,1,repr);
            return;
        }
      });
    }
    log("Cannot find indexed value within patient object ("+cType+"."+vID+")");
}
/*
* FUNCTION to create HTML from the original Build Template
*/
//load a section
function loadSection(section_data, patient_data, intervention_data){
    //initialize return snake
    var snake = "";var elem_attr={};var internal_snake="";
    
    //build the section from the ground up
    var sectName = jQuery(section_data).find("name").text();
    elem_attr['class']="block "+ sectName+"_heading";
    //Part A-1: Create the Heading div 
    var headerSnake="";
    //if the section has a title row which contains text add a header row
    jQuery(section_data).find(">text").each(function(){if(valueExists(this)){headerSnake += addHeaderRow(section_data,jQuery(this).text());}});
    //add references to the header div string
    jQuery(section_data).find('>reference').each(function(){headerSnake+=addReference(sectName,jQuery(this),"intralink "+sectName+"_reference");});
    internal_snake += htmlDOMelement("div",elem_attr,headerSnake);
    //use section data to help with display controls.
    var myArray=jQuery(intervention_data).find("dataRow>sectionName[text="+sectName+"]").parent().sort(onSalience);
    
    jQuery(myArray).each(function(){
        var dataRow=jQuery(this);//store the datarow
        var supData=dataRow.find(">supportData");
        var action='';dataRow.find(">action").each(function(){action+=resolveFormattingText(jQuery(this).text(),"",supData,intervention_data,patient_data)+";";});
        //develop the classList from preconditions (control display)
        var classList='';dataRow.find(">precondition").each(function(){
          classList+=jQuery(this).text()+" ";
          addDictionaryEntry("div_row_"+counter,jQuery(this).text());
        });
        //create an block div to contain the datarow
        var rowDiv_attr = {};var rowDiv_snake="";//jQuery("<div/>",{"class":classList}).appendTo(locDiv);
        rowDiv_attr['class']=classList+" regular_text center_align div_row "+sectName+"_div_row";
        rowDiv_attr['id']="div_row_"+counter;
        counter++;//adjust the number of rows in the counter
        //rowDiv_attr['data-action']=associateActions(action,intervention_data,patient_data);//TODO actions without elements
        //if there is a subheading, include the subheading
        rowDiv_snake += addSubHeaderRow(section_data,dataRow.find(">text"),"");
        //dataRow.find('>reference').each(function(){    addReference(rowdiv,sectName,jQuery(this),classList);});//TODO determine how to add references at the data_row level - not implemented
        //Part A-3: Load the dataFlows from the above dataRows into the dataRow div, create an inline div to store each dataFlow, add a default of silent to each data flow(?)
        dataRow.find(">dataFlow").each(function(){
          var dataFlow_snake="";var dataFlow_elem={};
          var classList='';//reset the classList
          jQuery(this).find(">precondition").each(function(){
            classList+=jQuery(this).text()+" ";
          });
          dataFlow_elem["class"]=classList +" inline regular_text center_align";
          //switch on type of dataFlow to determine building of next portion of HTML string
          var type = jQuery(this).find(">type").text();//only one type/dataflow
          switch(type){
            case "textbox":
              dataFlow_snake += addTextBoxDataFlow(intervention_data,section_data,dataRow,this,patient_data);break;
            case "label":
              dataFlow_snake += addLabelDataFlow(intervention_data,section_data,dataRow,this,patient_data);break;
            case "checkbox":
              dataFlow_snake += addCheckBoxDataFlow(intervention_data,section_data,dataRow,this,patient_data);break;
            case "radiobutton":
              dataFlow_snake += addRadioButtonDataFlow(intervention_data,section_data,dataRow,this,patient_data);break;
            case "button":
              dataFlow_snake += addButtonDataFlow(intervention_data,section_data,dataRow,this,patient_data);break;
            case "matrix-radiobutton":
              dataFlow_snake += addMatrixRBdataFlow(intervention_data,section_data,dataRow,this,patient_data);break;
            case "matrix-checkbox":
              dataFlow_snake +=addMatrixCBdataFlow(intervention_data,section_data,dataRow,this,patient_data);break;
            case "textarea":
              dataFlow_snake +=addTextAreaDataFlow(intervention_data,section_data,dataRow,this,patient_data);break;
            /*
            case "combobox":addComboBoxDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "hidden":addHiddenDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;*/
          }
          rowDiv_snake+=htmlDOMelement("div",dataFlow_elem,dataFlow_snake);//row_div is the level of visibility and access
        });
        internal_snake+=htmlDOMelement("div",rowDiv_attr,rowDiv_snake);
    });
    //snake+=htmlDOMelement("div",rowDiv_attr,internal_snake);
    snake+=internal_snake;
    //subsections
    jQuery(section_data).find(">subsection").each(function(){
        var sub_sect=jQuery(this);
        var sub_snake="";sub_snake_attr={};
        var sub_sect_name=sub_sect.text();
        var sub_sect_data = jQuery(intervention_data).find("section>name[text="+jQuery(this).text()+"]").parent();//xml search
        sub_snake_attr["class"]=sub_sect_name+" regular_text";
        sub_snake_attr["data-section"]=sub_sect_name;
        //build the sub_section
        //console.log(sub_sect_name);
        snake+=htmlDOMelement("div",sub_snake_attr,loadSection(sub_sect_data,patient_data,intervention_data));
    });
    //snake+=htmlDOMelement("div",rowDiv_attr,internal_snake);
    return snake;
}
//creates an HTML tag with attributes based on a tag, attribute array and a text field
function htmlDOMelement(element_tag,attribute_array,text){
  var snake = "";
  snake +="<"+element_tag;//opening tag
  //add each of the atrributes to the array (if there is a value)
  for (var attr in attribute_array){
    if(valueExists(attribute_array[attr])){
      snake +=" "+attr+" ='"+attribute_array[attr]+"'";//attr_id='attr_value'
    }
  }
  if(text||element_tag=="textarea"){//textarea requires <></> format
    snake+=">"//cap the element_tab opening
    snake+=text;//insert text/substatement
    snake+="</"+element_tag+">";//close the element
  }
  else{
    snake+="/>"
  }
  return snake;
}
//adds a headerRow for a section
function addHeaderRow(section_data,text){
  var sectName = jQuery(section_data).find(">name").text();//pull the section name from the XML
  var snake = "";
  //if there is a section name, return a section_name string within a span
  if(valueExists(text)){
    snake+= htmlDOMelement("span",{"class":"carea_heading "+sectName+"_heading"},text);
  }
  return snake;
}
//adds a subheading for a datarow
function addSubHeaderRow(section_data,text,altText){
  var sectName = jQuery(section_data).find(">name").text();
  //pull the section name into the class field to inplement localize css settings... _subheading
  var snake = "";
  var text=jQuery(text).text();//pull the text from xml
  if(valueExists(text)){
      elem_attr={};//initialize element attribute array
      elem_attr['class']="carea_subheading inline "+sectName+"_subheading";
      if(valueExists(jQuery(altText).text())){elem_attr["title"]=jQuery(altText).text();}
      //build HTML
      snake = htmlDOMelement("span",elem_attr,text);
  } 
  return snake;
}
/*INPUT CLASSES*/
function addTextBoxDataFlow(intervention_data,section_data,data_row,data_flow,patient_data){
  var snake = "";var elem_attr={};internal_snake="";
  var sectName = jQuery(section_data).find(">name").text();
  var df = jQuery(data_flow);
  var identity=df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text();
  var title=df.find('>altText').text();
  var desc=df.find('>description').text();
  var defaultValue=df.find('>defaultValue').text();
  var defaultText=df.find('>defaultText').text();
  var action='';df.find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';df.find(">precondition").each(function(){
    classList+=jQuery(this).text()+" ";
    //addDictionaryEntry(sectName+"_"+identity,jQuery(this).text());//register the precondition-unique ID with the datadictionary
  });
  //create a label for the text box (if needed)
  if(valueExists(df.find('>text').text())){internal_snake +=addLabel(sectName,df.find('>text').text(),title,classList);}
  //create the text box HTML string
  var auxClass=" textbox "+sectName+"_textbox";
  elem_attr['data-identity']=identity;//grouped identifier
  elem_attr['data-noteDetails']=desc;
  elem_attr['id']=sectName+"_"+identity;//unique identifier
  elem_attr['data-action']=action;
  internal_snake+=addInput("text","",title,classList+auxClass,defaultText,defaultValue,action,elem_attr);
  //add any reference to the HTML string
  df.find('>reference').each(function(){
    internal_snake+=addReference(sectName,jQuery(this),classList);
  });
  snake = internal_snake;//htmlDOMelement("div",elem_attr,internal_snake);
  return snake;
}
function addTextAreaDataFlow(intervention_data,section_data,data_row,data_flow,patient_data){
  //initialize snake
  var snake = "";var elem_attr={};
  //pull data
  var sectName = jQuery(section_data).find(">name").text();
  var df = jQuery(data_flow);
  var identity=df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text();
  var title=df.find('>altText').text();
  var supData=df.find(">supportData");
  var desc=df.find('>description').text();
  var defaultValue=df.find('>defaultValue').text();
  var defaultText=df.find('>defaultText').text();
  var action='';df.find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';df.find(">precondition").each(function(){
    classList+=jQuery(this).text()+" ";
    //addDictionaryEntry(sectName+"_"+identity,jQuery(this).text());//register the precondition-unique ID with the datadictionary
  });
  //header for textArea label is a seperate row above text area (with support and reference data)
  var header_snake="";header_attr={};
  header_attr['class']=classList +" block regular_text center_align";
  header_snake+=addLabel(sectName,df.find('>text').text(),title,classList);
  df.find('>reference').each(function(){    header_snake+=addReference(sectName,jQuery(this),classList);  });
  snake+=htmlDOMelement("div",header_attr,header_snake);
  //remainder is a div with the textArea
  //actions
  //var actionList = associateActions(elem,action,intervention_data,patient_data);
  elem_attr['title']=title;
  elem_attr['value']=defaultValue;
  elem_attr['placeholder']=defaultText;
  elem_attr["data-identity"]=identity;
  elem_attr["class"]="block regular_text center_align "+classList;
  elem_attr["id"]=sectName+"_"+identity;
  elem_attr["data-noteDetails"]=desc;
  //text area is not contained within a div by iteslf... not sure why this is or if it matters
  snake+=htmlDOMelement("textarea",elem_attr,"");//text areas require end tag to function appropriately
  return snake;
}
function addCheckBoxDataFlow(intervention_data,section_data,data_row,data_flow,patient_data,repr){
  //initialize strings
  var snake = "";var elem_attr={};internal_snake="";
  //pull data from XML/source
  var sectName = jQuery(section_data).find(">name").text();
  var df = jQuery(data_flow);
  var identity=df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text();
  var title=df.find('>altText').text();
  var supData=df.find(">supportData");
  var desc=resolveFormattingText(df.find('>description').text(),identity,supData,intervention_data,patient_data);
  var defaultValue=df.find('>defaultValue').text();
  var defaultText=df.find('>defaultText').text();
  var action='';df.find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';df.find(">precondition").each(function(){
    classList+=jQuery(this).text()+" ";
    //addDictionaryEntry(sectName+"_"+identity,jQuery(this).text());//register the precondition-unique ID with the datadictionary
  });
    //var linked = jQuery("input[type=checkbox][data-identity="+identity+"]",repr).attr('checked');
    //if(!valueExists(linked)){linked=false;}
  var auxClass=" checkbox "+sectName+"_checkbox";
  elem_attr['data-identity']=identity;//grouped identifier
  elem_attr['data-noteDetails']=desc;
  elem_attr['id']=sectName+"_"+identity;//unique identifier
  //actions
  //var actionList = associateActions(elem,action,intervention_data,patient_data);//need this to return a HTML string? or just a string to be inserted in elem_attr data-action
  internal_snake+=addInput("checkbox",false,title,classList+auxClass,"",defaultValue,action,elem_attr);
  //add label and support/reference to HTML string
  if(valueExists(df.find('>text').text())){internal_snake+=addLabel(sectName,df.find('>text').text(),title,classList);}
  df.find('>reference').each(function(){
    internal_snake+=addReference(sectName,jQuery(this),classList);
  });
  snake = internal_snake;//htmlDOMelement("div",elem_attr,internal_snake);
  return snake;
}
function addRadioButtonDataFlow(intervention_data,section_data,data_row,data_flow,patient_data,repr){
  //initialize strings
  var snake = "";var elem_attr={};internal_snake="";
  //pull data from XML/source
  var sectName = jQuery(section_data).find(">name").text();
  var df = jQuery(data_flow);
  var identity=df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text();
  var title=df.find('>altText').text();
  var supData=df.find(">supportData");
  var desc=resolveFormattingText(df.find('>description').text(),identity,supData,intervention_data,patient_data);
  var defaultValue=df.find('>defaultValue').text();
  var action='';df.find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';df.find(">precondition").each(function(){
    classList+=jQuery(this).text()+" ";
    //addDictionaryEntry(sectName+"_"+identity,jQuery(this).text());//register the precondition-unique ID with the datadictionary
  });
  var data_name=sectName+jQuery(data_row).find('>name').text();
  var auxClass=" radiobutton "+sectName+"_radiobutton";
  elem_attr['data-identity']=identity;//reciprocity identifier
  elem_attr['data-noteDetails']=desc;
  elem_attr['data-name']=data_name;//group identifier
  elem_attr['name']=data_name;//group identifier
  elem_attr['id']=sectName+"_"+identity;//unique identifier
  //actions
  //var actionList = associateActions(elem,action,intervention_data,patient_data);//need this to return a HTML string? or just a string to be inserted in elem_attr data-action
  internal_snake+=addInput("radio",false,title,classList+auxClass,"",defaultValue,action,elem_attr);
  //add label and support/reference to HTML string
  if(valueExists(df.find('>text').text())){internal_snake+=addLabel(sectName,df.find('>text').text(),title,classList);}
  df.find('>reference').each(function(){
    internal_snake+=addReference(sectName,jQuery(this),classList);
  });
  snake = internal_snake;//htmlDOMelement("div",elem_attr,internal_snake);
  return snake;
}
function addComboBoxDataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  /*var sectName = jQuery(section_data).find(">name").text();
  var df = jQuery(data_flow);
  var identity=df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text();
  var title=df.find('>altText').text();
  var defaultValue=df.find('>defaultValue').text();
  var action='';df.find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';df.find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //label and reference
  if(valueExists(df.find('>text').text())){addLabel(flowdiv,sectName,df.find('>text').text(),title,classList);}  
  df.find('>reference').each(function(){     addReference(sectName,jQuery(this),classList);  });
  //add the input - radioButtons have pre_sect_post as value AND sectName-->name
  var elem =jQuery("<select/>",{"class":"inline regular_text center_align "+classList,"type":type}).appendTo(flowdiv);
  jQuery(elem).addClass('combobox').attr("id",sectName+"_"+identity).addClass(sectName+"_combobox").attr("data-identity",identity).click(function (){reciprocity(this);});
  associateActions(elem,action,intervention_data,patient_data);
  if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title);}
  //add default option
  var opt =jQuery("<option/>",{"class":"inline regular_text center_align "+classList}).appendTo(flowdiv);
  jQuery(opt).addClass('option').addClass(sectName+"_option");
  jQuery(opt).text("Please select");  
  //add the options
  df.find("answer").each(function(){
    //create an option for each answer
      var identity=jQuery(this).find('>prefix').text()+df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text()+jQuery(this).find('>postfix').text();
      var title=df.find('>altText').text();
      var defaultValue=df.find('>defaultValue').text();
      var answerAction='';jQuery(this).find(">action").each(function(){action+=jQuery(this).text()+";";});
      var classList='';df.find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
      var opt =jQuery("<option/>",{"data-identity":identity,"class":"inline regular_text center_align "+classList}).appendTo(flowdiv);
      jQuery(opt).addClass('option').addClass(sectName+"_option");
      //actions
      associateActions(opt,answerAction);
      //other aspects
      if(valueExists(jQuery(this).find('>text').text())){jQuery(opt).text(jQuery(this).find('>text').text());}
      if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title);}
      if(valueExists(defaultValue)){jQuery(elem).attr("selected",defaultValue);}
  });*/
}
function addLabelDataFlow(intervention_data,section_data,data_row,data_flow,patient_data){
  var snake = "";var elem_attr={};
  var sectName = jQuery(section_data).find(">name").text();
  var df = jQuery(data_flow);
  var title=df.find('>altText').text();
  var supData=df.find(">supportData");
  var identity=df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text();
  var desc=resolveFormattingText(df.find('>description').text(),identity,supData,intervention_data,patient_data);
  var action='';df.find(">action").each(function(){action+=resolveFormattingText(jQuery(this).text(),"",supData,intervention_data,patient_data)+";";});
  var classList='inherit ';df.find(">precondition").each(function(){
    classList+=jQuery(this).text()+" ";
    //addDictionaryEntry(sectName+"_"+identity,jQuery(this).text());//register the precondition-unique ID with the datadictionary
  });
  //label and reference
  if(valueExists(df.find('>text').text())){ 
    var txt = df.find('>text').text();
    elem_attr['id']=sectName+"_"+identity;
    elem_attr['data-identity']=identity;
    elem_attr["data-noteText"]=title;
    elem_attr["data-noteDetails"]=desc;
    classList+=' dataflow_label '+sectName+'_dataflow_label';
    //add the intralink classess to dataflow lables with actions
    if(action.length>0){classList+=" dataflow_label_intralink";}
    txt = resolveFormattingText(txt,"",supData,intervention_data,patient_data);//replace the %1 tags with interm tags
    elem_attr['data-action'] = action;
    elem_attr['data-time']=preserveTimeStamp(supData);
    snake += addLabel(sectName,txt,title,classList,elem_attr);
  } 
  return snake;
}
function addButtonDataFlow(intervention_data,section_data,data_row,data_flow,patient_data){
  //initialize strings
  var snake = "";var elem_attr={};internal_snake="";
  //pull data from XML/source
  var sectName = jQuery(section_data).find(">name").text();
  var df = jQuery(data_flow);
  var identity=df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text();
  var title=df.find('>altText').text();
  var defaultValue=df.find('>defaultValue').text();
  var defaultText=df.find('>defaultText').text();
  var action='';df.find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';df.find(">precondition").each(function(){
    //addDictionaryEntry(sectName+"_"+identity,jQuery(this).text());//register the precondition-unique ID with the datadictionary
    classList+=jQuery(this).text()+" ";
  });
  //scan the system
  var auxClass=" button "+sectName+"_button";//extra classess for buttons
  elem_attr['data-identity']=identity;//grouped identifier
  elem_attr['id']=sectName+"_"+identity;//unique identifier
  internal_snake+=addInput("button",df.find('>text').text(),title,classList+auxClass,"",defaultValue,action,elem_attr);
  //add reference to HTML string
  df.find('>reference').each(function(){internal_snake+=addReference(sectName,jQuery(this),classList);});
  snake = internal_snake;
  return snake;
}
function addMatrixCBdataFlow(intervention_data,section_data,data_row,data_flow,patient_data,repr){
  //initialize strings
  var snake = "";var elem_attr={};internal_snake="";
  //pull data from XML/source
  var df = jQuery(data_flow);
  var sectName = jQuery(section_data).find(">name").text();
  var title=df.find('>altText').text();
  var defaultValue=df.find('>defaultValue').text();
  var classMatrix='matrix '+sectName+'_matrix';
  var classList='';df.find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //HEADING (labels and references)
  var heading_snake = "";heading_attr={};
  heading_attr["class"]=classList +" block regular_text center_align";
  if(valueExists(df.find('>text').text())){heading_snake+=addLabel(sectName,df.find('>text').text(),title,classList);}
  df.find('>reference').each(function(){heading_snake+=addReference(sectName,jQuery(this),classList);});
  internal_snake=htmlDOMelement("div",heading_attr,heading_snake);
  //MATRIX 
  //initialize the table
  var table_snake = "";table_attr={};var tr_snake = "";tr_attr={};
  table_attr["class"]=classMatrix;
  tr_attr['class']=classMatrix;
  //build the table up from its parts
  //build the top row
   //corner cell - spacer
    var td_attr={};//initialize the td attribute array
    td_attr['width']=calculateBuffer(section_data,data_row);
    tr_snake+=addLabelCell(sectName,"","",classMatrix,td_attr);
  //rest of the header row
  df.find(">answer").each(function(){
    var answer = jQuery(this);
    var title=answer.find('>altText').text();
    var txt=answer.find('>text').text();
    var classList='';answer.find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
    //add table row headers for revised type (empty) or answer with text (text)
    if(valueExists(answer.find(">revisedType").text())){tr_snake+=addLabelCell(sectName,"",title,classList+classMatrix+" answer_head");}
    else if(valueExists(txt)){tr_snake +=addLabelCell(sectName,txt,title,classList+classMatrix+' answer_head');};
  });
  //add the top row to the table
  table_snake+=htmlDOMelement("tr",tr_attr,tr_snake);
  //add the remaining rows to the table_snake
  //other rows
  df.find(">question").each(function(){
    var tr_snake="";var tr_attr={};
    //pull data
    var question = jQuery(this);
    var mIdentity=question.find('>prefix').text()+df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text()+question.find('>postfix').text();
    var title=question.find('>altText').text();
    var txt=question.find('>text').text();
    var supData=question.find('>supportData');
    var classList='';question.find(">precondition").each(function(){var txt = jQuery(this).text();classList+=txt+" ";});  
    tr_attr['class']=classMatrix+" div_row "+classList;
    //first column
    tr_snake+=addLabelCell(sectName,txt,title,classList+classMatrix+" regular_text matrix_question "+sectName+"_matrix_question");
    //other columns
    df.find(">answer").each(function(){
      //iinitialize answer cell
      var td_snake="";var td_attr={};
      //data 
      var answer = jQuery(this);
      var identity=answer.find('>prefix').text()+mIdentity+answer.find('>postfix').text();
      var title=answer.find('>altText').text();
      var txt=answer.find('>text').text();
      var rt = answer.find('>revisedType').text();
      var action='';answer.find(">action").each(function(){action+=resolveFormattingText(jQuery(this).text(),mIdentity,supData,intervention_data,patient_data)+";";});
      var classList='inherit ';answer.find(">precondition").each(function(){
        var classText = resolveFormattingText(jQuery(this).text(),mIdentity,supData,intervention_data,patient_data);
        classList+=classText+" ";
        //addDictionaryEntry(sectName+"_"+identity,classText);//register the precondition-unique ID with the datadictionary
      });
      //assign the classes to the table cell
      td_attr['class']=classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer";
      var input_snake="";input_attr={};
      if(!valueExists(rt)){
        //build the input
        input_attr['data-identity']=identity;
        input_attr['id']=sectName+"_"+identity;
        input_attr['data-answer']=txt;
        //input_attr['data-name']=mIdentity;
        //input_attr['name']=mIdentity;
        //console.log(mIdentity);
        input_snake+=addInput("checkbox","","",classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer checkbox "+sectName+"_checkbox","","",action,input_attr);
      }
      else{
         switch(rt){
            case "textbox":
              input_attr['data-identity']=identity;
              input_attr['id']=sectName+"_"+identity;      
              input_snake+=addInput("text","","",classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer textbox matrix_textbox "+sectName+"_textbox","","",action,input_attr);
              break;
            case "button":
              input_attr['data-identity']=identity;
              input_attr['id']=sectName+"_"+identity;      
              input_snake+=addInput("button",txt,"",classList+classMatrix+" button matrix_button "+sectName+"_button " + sectName+"_matrix_button","","",action,input_attr);
              break;
            case "label":
              td_attr['id']=sectName+"_"+identity;
              td_attr['title']=title;
              //td_attr['data-time']=preserveTimeStamp(supData);
              var elem = jQuery("<td/>",{"class":classList+" matrix_label"}).appendTo(tr);
              if(valueExists(txt)){
                input_snake=resolveFormattingText(txt,mIdentity,supData,intervention_data,patient_data);;
              }  
              break;
          }
      }
      //build the cell from the input/rt switch
      //var actionList = associateActions(action,intervention_data,patient_data);
      td_attr['data-name']=mIdentity;
      td_attr['data-answer']=txt;

      tr_snake+=addLabelCell(sectName,input_snake,"",classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer",td_attr);  
    });
    //build the table from the td_snake
    table_snake+=htmlDOMelement("tr",tr_attr,tr_snake);
  });
  //add the table to the internal snake
  internal_snake+=htmlDOMelement("table",table_attr,table_snake);
  snake+=internal_snake;
  return snake;
}
function addMatrixRBdataFlow(intervention_data,section_data,data_row,data_flow,patient_data,repr){
  //initialize strings
  var snake = "";var elem_attr={};internal_snake="";
  //pull data from XML/source
  var df = jQuery(data_flow);
  var sectName = jQuery(section_data).find(">name").text();
  var title=df.find('>altText').text();
  var defaultValue=df.find('>defaultValue').text();
  var classMatrix='matrix '+sectName+'_matrix';
  var classList='';df.find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //HEADING (labels and references)
  var heading_snake = "";heading_attr={};
  heading_attr["class"]=classList +" block regular_text center_align";
  if(valueExists(df.find('>text').text())){heading_snake+=addLabel(sectName,df.find('>text').text(),title,classList);}
  df.find('>reference').each(function(){
    heading_snake+=addReference(sectName,jQuery(this),classList);
  });
  internal_snake=htmlDOMelement("div",heading_attr,heading_snake);
  //MATRIX 
  //add the matrix
  var table_snake = "";table_attr={};var tr_snake = "";tr_attr={};
  table_attr["class"]=classMatrix;
  tr_attr['class']=classMatrix;

  //build the table up from its parts
  //build the top row
    //corner cell - spacer
     var td_attr={};//initialize the td attribute array
    td_attr['width']=calculateBuffer(section_data,data_row);
    tr_snake+=addLabelCell(sectName,"","",classMatrix,td_attr);
  //rest of the header row
  df.find(">answer").each(function(){
    var answer = jQuery(this);
    var title=answer.find('>altText').text();
    var txt=answer.find('>text').text();
    var classList='';answer.find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
    //add table row headers for revised type (empty) or answer with text (text)
    if(valueExists(answer.find(">revisedType").text())){tr_snake+=addLabelCell(sectName,"",title,classList+classMatrix+" answer_head");}
    else if(valueExists(txt)){tr_snake +=addLabelCell(sectName,txt,title,classList+classMatrix+' answer_head');};
  });
  //add the top row to the table
  table_snake+=htmlDOMelement("tr",tr_attr,tr_snake);
  //add the remaining rows to the table_snake
  //other rows
  df.find(">question").each(function(){
    var tr_snake="";var tr_attr={};
    //pull data
    var question = jQuery(this);
    var mIdentity=question.find('>prefix').text()+df.find('>prefix').text()+jQuery(data_row).find('>name').text()+df.find('>postfix').text()+question.find('>postfix').text();
    var title=question.find('>altText').text();
    var txt=question.find('>text').text();
    var supData=question.find('>supportData');
    var classList='';question.find(">precondition").each(function(){var txt = jQuery(this).text();classList+=txt+" ";});  
    tr_attr['class']=classMatrix+" div_row "+classList;
    //first column
    tr_snake+=addLabelCell(sectName,txt,title,classList+classMatrix+" regular_text matrix_question "+sectName+"_matrix_question");
    //other columns
    df.find(">answer").each(function(){
      //iinitialize answer cell
      var td_snake="";var td_attr={};
      //data pull
      var answer = jQuery(this);
      var identity=answer.find('>prefix').text()+mIdentity+answer.find('>postfix').text();
      var title=answer.find('>altText').text();
      var txt=answer.find('>text').text();
      var rt = answer.find('>revisedType').text();
      var action='';answer.find(">action").each(function(){action+=resolveFormattingText(jQuery(this).text(),mIdentity,supData,intervention_data,patient_data)+";";});
      var classList='inherit ';answer.find(">precondition").each(function(){
        var classText = resolveFormattingText(jQuery(this).text(),mIdentity,supData,intervention_data,patient_data);
        classList+=classText+" ";
        //addDictionaryEntry(sectName+"_"+identity,classText);//register the precondition-unique ID with the datadictionary
      });
      //assign the classes to the table cell
      td_attr['class']=classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer";
      var input_snake="";input_attr={};
      if(!valueExists(rt)){
        //build the input
        input_attr['data-identity']=identity;
        input_attr['id']=sectName+"_"+identity;
        input_attr['data-name']=mIdentity;
        input_attr['name']=mIdentity;
        input_attr['data-answer']=txt;
        input_snake+=addInput("radio","","",classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer radiobutton "+sectName+"_radiobutton","","",action,input_attr);
      }
      else{
         switch(rt){
            case "textbox":
              input_attr['data-identity']=identity;
              input_attr['id']=sectName+"_"+identity;      
              input_snake+=addInput("text","","",classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer textbox matrix_textbox "+sectName+"_textbox","","",action,input_attr);
              break;
            case "button":
              input_attr['data-identity']=identity;
              input_attr['id']=sectName+"_"+identity;      
              input_snake+=addInput("button",txt,"",classList+classMatrix+" button matrix_button "+sectName+"_button " + sectName+"_matrix_button","","",action,input_attr);
              break;
            case "label":
              td_attr['id']=sectName+"_"+identity;
              td_attr['title']=title;
              //td_attr['data-time']=preserveTimeStamp(supData);
              var elem = jQuery("<td/>",{"class":classList+" matrix_label"}).appendTo(tr);
              if(valueExists(txt)){
                input_snake=resolveFormattingText(txt,mIdentity,supData,intervention_data,patient_data);
              }  
              break;
          }
      }
      //build the cell from the input/rt switch
      //var actionList = associateActions(action,intervention_data,patient_data);
      td_attr['data-name']=mIdentity;
      td_attr['data-answer']=txt;
      tr_snake+=addLabelCell(sectName,input_snake,"",classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer",td_attr);  
    });
    //build the table from the td_snake
    table_snake+=htmlDOMelement("tr",tr_attr,tr_snake);
  });
  //add the table to the internal snake
  internal_snake+=htmlDOMelement("table",table_attr,table_snake);
  snake+=internal_snake;
  return snake;
}
function addLabelCell(sectName,txt,title,classList,otherAttributes){
    var snake = "";var elem_attr={};
    elem_attr['class']=classList;
    //internal txt
    if(valueExists(txt)){snake+=htmlDOMelement("span",{"class":"regular_text "+classList},txt);}  
    if(valueExists(title)){elem_attr["title"]=title;}
    for(var key in otherAttributes){elem_attr[key]=otherAttributes[key];}//pull in the other attributes
    snake=htmlDOMelement("td",elem_attr,snake);
    return snake;
  }
//grab the supportData containing the element time stamp reference link
function preserveTimeStamp(supData){
  if(supData!=null){
      for(var jj=0;jj<supData.length;jj++){
         var txt = jQuery(supData[jj]).text();
         if(valueExists(txt)&&txt.indexOf('.instant')>0){
              var txt="<%="+txt+"%>";//prepares for NODE replacement of values
              return txt;
         }
      }
  }
  return "";//return an empty string
}
function addInput(type,value,title,classList,defaultText,defaultValue,actionList,otherAttributes){
    //text and action do not appear to be used, nor is flowdiv
    var snake = "";var elem_attr={};
    elem_attr['class']="inline regular_text center_align "+classList;
    elem_attr['value']=value;
    elem_attr['type']=type;
    if(valueExists(defaultValue)){elem_attr["checked"]=defaultValue;}
    if(valueExists(defaultText)){elem_attr["placeholder"]=defaultText;}
    if(valueExists(title)){elem_attr["title"]=title;}
    if(valueExists(actionList)){elem_attr["data-action"]=actionList;}
    for(var key in otherAttributes){elem_attr[key]=otherAttributes[key];}//pull in the other attributes
    snake=htmlDOMelement("input",elem_attr);
    return snake;
}
function calculateBuffer(section_data,data_row){
  var ii = jQuery(section_data).find(">text").text().length;
  var jj = jQuery(data_row).find(">text").text().length;
  var snake = (jj>0?(jj+4)*8+'px':ii*8+'px');//account for subheading indent with 2letters extra
  return snake;
}
//function reoorders div_rows
function onSalience(a,b){
  var x = jQuery(a).find(">salience").text();
  var y = jQuery(b).find(">salience").text();
  return ((y==""?0:y*1)-(x==""?0:x*1));
}
function addLabel(sectName,text,title,classList,otherAttributes){
  var snake = "";var elem_attr={};//initialize
  elem_attr['class']="inline label regular_text center_align "+classList+" "+sectName+"_label";
  if(valueExists(title)){elem_attr['title']=title;}
  for(var key in otherAttributes){elem_attr[key]=otherAttributes[key];}//pull in the other attributes
  snake +=htmlDOMelement("span",elem_attr,text);
  return snake;
}
function addReference(sectName,reference,classList){
  var snake = "";var elem_attr={};var tag="";//initialize snake
  //reference is either a text or an image as the link
  var val=jQuery(reference).find('>text').text();
  //select class of reference (text or image)
  if(valueExists(val)){  
    elem_attr['class']="regular_text padded_label "+classList+" reference "+sectName+"_reference";
    tag="a";
  }
  else{
    elem_attr['class']="preview_image "+classList+" reference "+sectName+"_reference";
    tag="span";
  }
  //create attr_link for url (if it exists)
  var href = jQuery(reference).find('href').text();
  if(valueExists(href)){
    elem_attr["url"]=href;
    elem_attr['class']+=" intralink";
  }
  var file = jQuery(reference).find('file').text();
  if(valueExists(file)){
    elem_attr["url"]=file;
    elem_attr['class']+=" intralink";
  }
  snake +=htmlDOMelement(tag,elem_attr,val);
  return snake;//return snake

}
//For text (class name)
function resolveFormattingText(txt,lnk,keys,intervention_data,patient_data){
  if(valueExists(txt)){
    txt=txt.replace('%q.','');//should not need %q in %1 call, %q is assumed in matrix
    txt=txt.replace('%q',lnk);//replace without dot using lnk
    //replace keys
    if(valueExists(keys)){
      var arr = jQuery.makeArray(keys);
      var jj=1;
      for(var val in arr){
        //grab the data
        var tmp = jQuery(arr[val]).text();
        if(equalsIgnoreCase(tmp,'constants.datetime')){
            txt=txt.replace('%'+jj++,"<%=constants.datetime%>");  
        }
        else{
            txt=txt.replace('%'+jj++,"<%="+jQuery(arr[val]).text()+"%>");//prepares for NODE replacement of values
        }
      }
    }
    return txt;
  }
  return txt;
}
function determineReferenceData(txt,patient_data,intervention_data,elem){
  //create the return
  var p=jQuery("<p/>").addClass("inline");
  //if patient data
  if(txt.indexOf('patient')!=-1){
    try{
      var cID = txt.split(".");
      var index = cID[1];
      var store = patient_data.data;
      var key = (cID[2]||"value");
      if(exists(elem)){
        if(exists(store[index][key])) {
          elem.attr("data-time",store[index].instant);
        }
      }
      jQuery(p).text(store[index][key]);    
    }
    catch(err){
      log("Could not access patient data:"+txt);
    }
  }
  else if(txt.indexOf('constants')!=-1){
    //grab the concept from the json
    var key = txt.split(".")[1];
    jQuery(p).text(patient_data.constants[key]);
  }
  //otherwise retain the value
  else{
    jQuery(p).text(txt);
  }
  return jQuery(p).html();
}
function determineReferenceDataText(txt,patient_data){
  var snake = txt;
  if(txt.indexOf('patient')!=-1){
    try{
      var cID = txt.split(".");
      var index = cID[1];
      var store = patient_data.data;
      var key = (cID[2]||"value");
      //console.log(store[index][key]);
      return store[index][key];    
    }
    catch(err){
      log("Could not access patient data:"+txt);
    }
  }
  else if(txt.indexOf('constants')!=-1){
    //grab the concept from the json
    var key = txt.split(".")[1];
    //console.log(patient_data.constants[key]);
    return patient_data.constants[key];
  }
  return snake;
}
var templateBuild = 
  function(obj){
  var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};
  with(obj||{}){
  __p+='﻿<div id="carea_hwi_internal"><div id="carea_hwi_top_div"><span class="img_parent dumbell_image"></span><span class="title"><p class="title padded_label"><span class="title_div indent_image">Healthy Weight Care Assistant</span></p><div class="section_div" data-section ="Heading"></div></span></div><div id="carea_hwi_left_side"><div class="section_div" data-section ="Document"></div><div class="section_div" data-section ="FamHx"></div><div class="section_div" data-section ="Comorbidities"></div><div class="section_div" data-section ="Dx"></div></div><div id="carea_hwi_right_side"><div class="section_div" data-section ="Eval"></div><div class="section_div" data-section ="Goals"></div><div class="section_div" data-section ="Resource"></div><div class="section_div" data-section ="FollUp"></div><div class="section_div" data-section ="Pathway"></div><div class="section_div" class="center" data-section ="Build"><input type="button" id="carea_hwi_save_button" value="Build Documentation and Order Set"></div></div><div id="carea_hwi_popup" class="silent"><label id ="carea_hwi_clear_label" class="intralink fine_print float_label fixed">Clear Section</label><label id ="carea_hwi_save_label" class="intralink fine_print float_label fixed">Save/Exit</label></div></div>';
  }
  return __p;
  };
/*less old */
/* BUILD FUNCTIONS */
/*
function lookupValueScrape(scrape,link,identifier){
  if(scrape[link][identifier]!=null){
    return scrape[link][identifier];
  }
  log("Could not find in patient object: section="+link+", with instance of "+identifier);
  return "";
}
//calculates the age of a patient
function convertYears(bd){
  //source: http://www.romcartridge.com/2010/01/javascript-function-to-calculate-age.html, modified
  //birthday (yyyy-mm-dd)
  var bdSplits=bd.split("-");
  var birthYear=bdSplits[0];
  var birthMonth=bdSplits[1]-1;
  var birthDay=bdSplits[2];
  //today
  var todayDate = new Date();
  todayYear = todayDate.getFullYear();
  todayMonth = todayDate.getMonth();
  todayDay = todayDate.getDate();
  //age calculator
  age = todayYear - birthYear;
  if (todayMonth < birthMonth){age--;}
  if (birthMonth == todayMonth && todayDay < birthDay){age--;}
  return age;
}*/
//MODERATELY OLD - unsure if needed
//replace the variables
function replaceVariables(repr,patient){
  /*jQuery(repr).find("span[data-action],input[type=button],input[type=checkbox]").each(function(){
    //text
    var ths = jQuery(this);
    if(valueExists(ths.text())){
      while(ths.text().indexOf("%_")!=-1){
        var srt = ths.text().indexOf("%_");
        var end = ths.text().indexOf("_%");
        var substring = ths.text().substring(srt+2,end);
        ths.text(ths.text().replace("%_"+substring+"_%",determineReferenceData(substring,patient,null,ths)));
      }
    }
    if(valueExists(ths.attr('data-action'))&&ths.attr('data-action').indexOf("%_")!=-1){
      var occ = ths.attr('data-action').split("_%");
      for(var key in occ){
        var srt = occ[key].indexOf("%_");
        if(srt!=-1){
          var substring = occ[key].substring(srt+2);
          var repl = determineReferenceDataText(substring,patient);
          occ[key]=occ[key].replace("%_"+substring,repl);
        }
      }
      ths.attr('data-action',occ.join(''));
    }
    if(valueExists(ths.attr('data-noteDetails'))&&ths.attr('data-noteDetails').indexOf("%_")!=-1){
      var occ = ths.attr('data-noteDetails').split("_%");
      for(var key in occ){
        var srt = occ[key].indexOf("%_");
        if(srt!=-1){
          var substring = occ[key].substring(srt+2);
          //console.log(substring);
          var repl = determineReferenceDataText(substring,patient);
          occ[key]=occ[key].replace("%_"+substring,repl);
        }
      }
      ths.attr('data-noteDetails',occ.join(''));
    }
  });*/
}

//VERY OLD
/**
This function pulls directly from the patient scrape
**/
/*
function encounterValues(patient,xml){
  var data={};
  for(var instance in patient.encounters){
    var enc=patient.encounters[instance];
    var instant = enc.instant;
    for(var proc in enc.procedures){
      var panel = enc.procedures[proc];
      for(var result in panel.results){
        //grab the index
        var ind = xmlDDIndex(xml,"cpt",panel.cpt,"name",panel.results[result].component+"");
        //if data.index exists then replace if instant>data.index.instant    
        if(!valueExists(data[ind])||data[ind].instant<instant){
            data[ind]={
              "type":"procedure",
              "cpt":""+panel.cpt,
              "instant":enc.instant,
              "name":panel.results[result].component+"",
              "value":(panel.results[result].numericResult!=null?panel.results[result].numericResult+"":panel.results[result].textResult),
              "low":panel.results[result].referenceLow+"",
              "high":panel.results[result].referenceHigh+""
            }
        }
      }
    }
    for(var flow in enc.flowsheets){
        var ind =xmlDDIndexShort(xml,"floid",enc.flowsheets[flow].floid);
        //if data.index exists then replace if instant>data.index.instant    
        if(!valueExists(data[ind])||data[ind].instant<instant){
            data[ind]={
              "type":"flowsheet",
              "floid":enc.flowsheets[flow].floid,
              "instant":enc.instant,
              "value":enc.flowsheets[flow].value
          }
        }
    }
  }
  return data;
}*/
/**
* Index incoming lab data from patient scrape
**/
/*function xmlDDIndex(xml,valueID,value,subConceptValueID,subConceptValue){
  var snake = jQuery(xml).find("concept").filter(function(){
    //determine if it is the correct class of object
    return equalsIgnoreCase(jQuery(this).find(">valueId").text(),valueID)
    &&equalsIgnoreCase(jQuery(this).find(">subConceptValueId").text(),subConceptValueID);
  }).filter(function(){
     //second filter is on value match
        return (jQuery(this).find(">value").filter(function(){
            return equalsIgnoreCase(jQuery(this).text(),value);
        }).length)>0;
  }).filter(function(){
     //second filter is on value match
        return (jQuery(this).find(">subConceptValue").filter(function(){
            return equalsIgnoreCase(jQuery(this).text(),subConceptValue);
        }).length)>0;
  }).find("conceptId").text();
  return snake;
}*/
/**
* Index incoming non-lab data from patient scrape
**/
/*function xmlDDIndexShort(xml,valueID,value){
  var snake = jQuery(xml).find("concept").filter(function(){
    //determine if it is the correct class of object
    return equalsIgnoreCase(jQuery(this).find(">valueId").text(),valueID);
  }).filter(function(){
     //second filter is on value match
        return (jQuery(this).find(">value").filter(function(){
            return equalsIgnoreCase(jQuery(this).text(),value);
        }).length)>0;
  }).find("conceptId").text();
  return snake;
}*/

//preformat data from json_data
/*
function preFormat(patient,xml){
  var bd = patient.birthDate;
  var name = lookupValueScrape(patient,"demographics","name");
  var street = lookupValueScrape(patient,"demographics","street");
  var city = lookupValueScrape(patient,"demographics","city");
  var zip = lookupValueScrape(patient,"demographics","zipcode");
  //if there is no payor
  if(!valueExists(patient.demographics.payor)){
    patient.demographics.payor="Other";
  }
  patient.constants = {
              "age_years":convertYears(bd),
              "name":name,
              "first_name":name.substring(name.indexOf(",")+1),
              "last_name":name.split(",")[0],
              "address":street+"\n"+city+" "+zip,
              "street":street,
              "city":city,
              "zip":zip
            }
  //pull labs,vitals... from patient object, using data_dictionary and format for the intervention
  var pertinentData = encounterValues(patient,xml);
  patient.data = pertinentData;
  //console.log(JSON.stringify(patient.data));
 return patient;      
}
*/
/*function associateActions(elem,actionList,intervention_data,patient_data){
  if(valueExists(actionList)){
    jQuery(elem).attr('data-action',actionList);
    //1 - split on ";"
    var soa = actionList.split(";");
    var tmp="";
    for(var ii=0;ii<soa.length-1;ii++){
      var actionClass=soa[ii].substring(0,soa[ii].indexOf("::"));
      var tgt =soa[ii].substring(soa[ii].indexOf("::")+2);
      //onload actions
      switch(actionClass){
            case "show":break;
            case "click":break;
            case "apply":break;
            case "order":break;
            case "diagnosis":break;
            case "revise":break;//indicate a element to change in the future
            case "revised":
              elem.attr("data-revised",tgt);
              break;
            case "require":
              //if there is no data the first char of tgt will be % or tgt length will be 0 (if prefromatted)
              //if(tgt.indexOf("%")==0||tgt.length==0){jQuery(elem).text("");}
              break;
            case "intralink":
            case "link":
                jQuery(elem).addClass("intralink");break;
            case "flagSilent":
             applyFlag(tgt,elem,false); break;
            case "flag":
              applyFlag(tgt,elem,true); break;
             
      }
      //delayed actions use stored variable function method
      jQuery(elem).click((function(actionClass,tgt){
        return function(){
          switch(actionClass){
            case "show":
              createWindow(tgt);
             break;
            case "click":
              jQuery("[data-identity="+tgt+"]:not(:checked)").click();
              break;
            case "apply":break;
            case "order":break;
            case "revise":
              reviseElem(tgt);break;
            case "diagnosis":break;
            case "intralink":
              openWindow(tgt);break;
            case "link":
              openWebsite(tgt);break;
          }
        };
      }(actionClass,tgt)));
    } 
  } 
}*/